/* 
**
****************************************************************************
**
**
**             쌠 (c) 2007 - Atmel Corporation
**             L
**
** 		: ATmega88+ATA6824 
** Pʕ	: main.c
** 		: DCd@
**			  "Hد "ł̎gp̂
**
**  :  		  t: : :
** 1.0   2007N212  F.G.  쐬
**
** LICENSE -
**
** ATMEL - 2007
** SĂ̿ĳ ۸т͔@Ȃۏ؂Ȃu󂻂̂܂܁vŒ񋟂܂B
** Atmel͔@ȂړIɑ΂Ă񋟂̓K𖾌܂Bَ̕
** ؁A̖ړIւ̓KAAyєNQ܂݁A񋟂ĳɊւS
** Ă̕ۏ؂ƏAtmel͂Ŕ۔F܂BAtmelͿĳ ۸ׂ̎g
** ̔@ȂԐړI܂͌ʂƂĐ鑹Q܂@Ȃ鑹Qɑ΂ĂӔC
** ܂B
****************************************************************************
**
*/


/*_____ ˭ލ\ݒ _____________________________________________________*/

/* - 8MHzRCUgp
 *
 * ˭ލ\ݒɉMCUnԂɂĂ̒:
 * - 0ms܂4.1msMCUnԂݒ肷悤˭ލ\ݒŒӂׂł(ł65msɐݒ肳Ă܂)B
 * - ATA6824͑\I10%e덷rd=68ms̑OɳޯދN҂܂B
 * - ̎Ԃ̊ԒɋNNƁAMCUؾĂ܂B
 * - MCUnԂ65msɐݒ肳AؾĂNOtd(10%덷68ms)ɊւĒ邩܂B
 *   td<65ms̏ꍇAMCUWDN𐶐邱Ƃł܂BʂƂāAؾĂɐ旧MCUJnł܂B
 ***************************************************************************/


/*_____ ݸٰ ____________________________________________________________*/

#include "config.h"
#include "ADC_task.h"		// d@dA]ޑxAVbat̎ɎgADC
#include "Timer0_PWM.h"		// PWMƿĳԐɎgv0
#include "ATA6824_defs.h"	// ATA6824Lٰ(WDAff)
#include "Hall_sensors.h"	// ΰيmݕω荞(PCINT0)Ǘ
#include "an_compare.h"		// ߓd󋵌o


/*_____ ϸ ________________________________________________________________*/

/*_____ ` _______________________________________________________________*/

//! @defgroup Motor_control d@Ԓ`
//! DCd@Ǘ邽߂main()Ŏgp
//! @{
typedef enum
{
	MOTOR_STATUS_STOPPED,	//!< d@~
	MOTOR_STATUS_CW,		//!< vœd@s
	MOTOR_STATUS_CCW		//!< vœd@s
} Motor_ctrl_t;				//!< d@ǗɎg^
//! @}

/*_____ ^錾 ___________________________________________________________*/

void display_defaults(void);	// LEDł̏Qo


/*_____ Sϐ ___________________________________________________________*/

/**
 * @fn main ADC̎ǗAԁAޯލXVAd@AQ\Ɖ
 **/
void main(void)
{
	Motor_ctrl_t motor_status = MOTOR_STATUS_STOPPED;

	CLKPR   = 0x80;
	CLKPR   = 0x00;					//  ۯOuȂ
	CONFIG_IO_PORTS();				// o߰č\ݒ

	ADC_Init();						// ADC
	Timer0_start();					// 31250Hz PWMƎԊǗpv0Jn
	Hall_sensors_ISR_init();		// ݕω荞(PCINT0)\ݒ
	Diag_inputs_ISR_init();			// DG1/2/3ݕω荞(PCINT1)\ݒ
	AN_compare_init();				// ۸ޔrʂߓdo\ݒ

	SET_WD_TRIG();					// 񳫯ޯލXV

	__enable_interrupt();			// S̊荞݋

	while(1)						// I薳JԂ
	{
		ADC_task();					// ADC̎Ǘ
		manage_time_base();			// ԊǗ
		refresh_ATA6824_watchdog();	// ATA6824ޯލXV

		/* d@Ǘ */
		switch(motor_status)
		{
		//--------------------------------------------------------------------
		 case MOTOR_STATUS_STOPPED:						// d@͒~܂B
			if (GET_SWITCH_CW())
			{
				SET_MOTOR_DIR();						// d@ݒ
				TIMER0_SET_OC0B_PWM((U8)((adc_get_speed()>>2)));	// PWMXV
				motor_status = MOTOR_STATUS_CW;
			}
			else if (GET_SWITCH_CCW())
			{
				RESET_MOTOR_DIR();						// d@ؾ
				TIMER0_SET_OC0B_PWM((U8)((adc_get_speed()>>2)));	// PWMXV
				motor_status = MOTOR_STATUS_CCW;
			}
			else
				TIMER0_SET_OC0B_PWM(0x00);				// PWM0ɐݒ
			break;

		//--------------------------------------------------------------------
		case MOTOR_STATUS_CW:							// d@͎vős
		case MOTOR_STATUS_CCW:							// d@͔vős

			if (!GET_SWITCH_CW() && !GET_SWITCH_CCW())	// ؑ֊킩̒~w
			{
				TIMER0_SET_OC0B_PWM(0x00);				// PWM0ɐݒ
				motor_status = MOTOR_STATUS_STOPPED;	// d@ԍXV
			}
			else
				TIMER0_SET_OC0B_PWM((U8)((adc_get_speed()>>2)));	// PWMXV
			break;

		//--------------------------------------------------------------------
		default:
			motor_status = MOTOR_STATUS_STOPPED;
			TIMER0_SET_OC0B_PWM(0x00);					// PWM0ɐݒ
			break;
		}

		// LEDł̊\
		display_defaults();

		// JtAQcĂȂɏQ
		if (GET_RELEASE_BP())
			clear_faults();			// (ĳɂׯꂽ)cĂQ
	};
}


/*! @brief display_defaults͐ffQoƂgp҂ɍ}܂B
 *  ΉLED\܂B2̏QͿĳׯ܂B̐Uׯ
 *  ƁAΉLEDONɐݒ肳܂B͏Qׯꂽɉ
 *  ܂BDG3x߂ׯKv܂Bꂪ݂AΉ
 *  LEDݐ؂ւǍɑ݂ȂȂΉ܂B
 */
void display_defaults(void)
{
	// HZo(ׯꂽDG1M)\
	if (ATA6824_diag_mgt.dg1 != NO_FAILURE)    SET_DG1_LED();
	else                                       RESET_DG1_LED();

	// ެ ߏQAߏd܂͉ߓdo(ׯꂽDG2M)\
	if (ATA6824_diag_mgt.dg2 != NO_FAILURE)    SET_DG2_LED();
	else                                       RESET_DG2_LED();

	// xߏ󋵂DG3_LEDݐ؂ւ
	if (time_count_1s.ovf == true)
	{
		if (ATA6824_diag_mgt.dg3 != NO_FAILURE)
			TOGGLE_DG3_LED();
		else
			RESET_DG3_LED();
		time_count_1s.ovf = false;		// ׸މ
	}
}
