/*
**
****************************************************************************
**
**
**             쌠 (c) 2007 - Atmel Corporation
**             L
**
** 		: ATmega88+ATA6824 
** Pʕ	: ATA6824_defs.c
** 		: DCd@
**			  "Hد "ł̎gp̂
**
**  :  		 t: : :
** 1.0   2007N35  F.G.  쐬
**
** LICENSE -
**
** ATMEL - 2007
** SĂ̿ĳ ۸т͔@Ȃۏ؂Ȃu󂻂̂܂܁vŒ񋟂܂B
** Atmel͔@ȂړIɑ΂Ă񋟂̓K𖾌܂Bَ̕
** ؁A̖ړIւ̓KAAyєNQ܂݁A񋟂ĳɊւS
** Ă̕ۏ؂ƏAtmel͂Ŕ۔F܂BAtmelͿĳ ۸ׂ̎g
** ̔@ȂԐړI܂͌ʂƂĐ鑹Q܂@Ȃ鑹Qɑ΂ĂӔC
** ܂B
****************************************************************************
**
*/
/*_____ ݸٰ ____________________________________________________________*/

#include "config.h"
#include "ATA6824_defs.h"
#include "Timer0_PWM.h"		// WDXVٰ݂ɂĕKvƂ鎞Ԃ𐶐

/*_____ ϸ ________________________________________________________________*/

/*_____ ` _______________________________________________________________*/

/*_____ ^錾 ___________________________________________________________*/

/*_____ Sϐ ___________________________________________________________*/

ATA6824_diag_mgt_t  ATA6824_diag_mgt;	//<! QǗ܂B



/*! @brief refresh_watchdog (ORɂČŒ艻ꂽ)KvƂXV
 *  ɏ]ATA6824OޯނXV
 *
 *  ٰ݂͊Jt2(ްĎQ)̊ԂATA6824WDN݂ŏ㏸[𐶐
 *  ߂ɿĳԂg܂B
 *
 *  @warning : v0̕ύX͊ԁÂɳޯލXVɉe
 *  yڂ܂B
 */
void refresh_ATA6824_watchdog(void)
{
	static unsigned int last_count=0;		// ŌWDNuԂL
	signed int dif;

	// ŌWDŇoߎԂvZ
	dif = last_count - (U16)(time_count_1s.count);

	if (dif<0)
		{dif = dif + ONE_SECOND; };			// Ԍvꏈ

	// ŌWDŇoߎԂ𒲍
	if (dif > WD_TIME_TRIG)
	{
		// oߎɳޯދN݂ݐ؂ւ
		TOGGLE_WD_TRIG();
		last_count = time_count_1s.count;	// ŌWDNuԂL
	}
}


/*! @brief Diag_inputs_ISR_init ͐ffݕω荞ݏ
 *  - PCINT14`8Օ
 *  - DG1,DG2,DG3(eXPCINT10,PCINT11,PCINT12)㏸܂͉~̗[ł̊荞
 *    ݐɍ\ݒ
 */ 
void Diag_inputs_ISR_init(void)
{
	/* PCINT1ݕω荞ݏ */
	// PCINT14`8荞݋
	PCICR |= 1 << PCIE1;
	// PCINT10/11/12荞݋
	PCMSK1 |= (1 << PCINT12) | (1 << PCINT11) | (1 << PCINT10);
}


/*! @brief Diag123_ISR() DG1,DG2,DG3ݕω荞ݏ
 *  ̊荞ݻٰ݂͐ffݕωł̊荞ݐ܂BDG2DG3̐ff
 *  M(ŁA ߏQ/ߏd/ߓd/HZ)ׯ܂B(ĳ
 *  ɂׯȂ)xߏԂ񍐂܂B
 */
#if defined(__ICCAVR__)				// IAR߲׎gp
#pragma vector= PCINT1_vect			// ATmega88pݕω荞10޸
__interrupt void Diag123_ISR (void)
#elif defined (__AVR__)				// AVR-GCC߲׎gp
ISR(PCINT1_vect)
#endif
{
	if (GET_DG1_STATUS())
		ATA6824_diag_mgt.dg1 = LATCHED_FAILURE;		// HZQׯ

	if (GET_DG2_STATUS())
		ATA6824_diag_mgt.dg2 = LATCHED_FAILURE;		//  ߂܂͓d̏Qׯ

	if (GET_DG3_STATUS())
		ATA6824_diag_mgt.dg3 = WARNING;				// xߌx}
	else
		ATA6824_diag_mgt.dg3 = NO_FAILURE;			// xߌx
}



/*! @brief clear_faults ĳ ׯQ
 *  QׯĂ݂Ȃׯ
 */
void clear_faults(void)
{
  if ( (ATA6824_diag_mgt.dg1 == LATCHED_FAILURE) && (!GET_DG1_STATUS()) )
  {
    // ݂ȂꍇɌoHZׯ
    ATA6824_diag_mgt.dg1 = NO_FAILURE;
  }
  
  if ( (ATA6824_diag_mgt.dg2 == LATCHED_FAILURE) && (!GET_DG2_STATUS()) )
  {
    // ݂Ȃꍇ ߏQAߏdAߓdׯ
    ATA6824_diag_mgt.dg2 = NO_FAILURE;
  }
}
